#include <sys/uio.h>

#include "memory.h"
#include "log.h"

// Store PID
static pid_t guest_pid;
void init_memory(pid_t pid) {
    guest_pid = pid;
}

// Read Memory
void memory_reader(uint32_t guest_addr, void *data, uint32_t size) {
    iovec local[1];
    local[0].iov_base = data;
    local[0].iov_len = size;
    iovec remote[1];
    remote[0].iov_base = (void *) (uint64_t) guest_addr;
    remote[0].iov_len = size;
    ssize_t ret = process_vm_readv(guest_pid, local, 1, remote, 1, 0);
    if (ret != size) {
        ERR("Unable To Read Data");
    }
}

// Write Memory
void memory_writer(uint32_t guest_addr, void *data, uint32_t size) {
    iovec local[1];
    local[0].iov_base = data;
    local[0].iov_len = size;
    iovec remote[1];
    remote[0].iov_base = (void *) (uint64_t) guest_addr;
    remote[0].iov_len = size;
    ssize_t ret = process_vm_writev(guest_pid, local, 1, remote, 1, 0);
    if (ret != size) {
        ERR("Unable To Write Data");
    }
}